package roleypoly

import (
	"net/http"

	"github.com/goccy/go-json"
	"github.com/gofiber/fiber/v3"
	"github.com/gofiber/fiber/v3/middleware/session"
	"github.com/gofiber/template/html/v2"

	"git.sapphic.engineer/roleypoly/v4/templates"
	"git.sapphic.engineer/roleypoly/v4/testing"
)

func CreateFiberApp() *fiber.App {
	viewEngine := html.NewFileSystem(http.FS(templates.FS), ".html")

	app := fiber.New(fiber.Config{
		JSONEncoder: json.Marshal,
		JSONDecoder: json.Unmarshal,
		Views:       viewEngine,
		ViewsLayout: "layouts/main",
	})

	app.Use(session.New(session.Config{}))

	return app
}

func SetupRoutes(app *fiber.App) {
	(&testing.TestingController{}).Routes(app.Group("/testing"))
}

// func getStorageDirectory() string {
// 	path := os.Getenv("STORAGE_DIR")
// 	if path == "" {
// 		path = "./.storage"
// 	}

// 	_, err := os.Stat(path)
// 	if err != nil {
// 		if os.IsNotExist(err) {
// 			err := os.MkdirAll(path, 0744)
// 			if err != nil {
// 				log.Fatalln("failed to create storage directory: ", err)
// 			}
// 		}
// 	}

// 	return path
// }
