package testing

import (
	"log"

	"github.com/gofiber/fiber/v3"

	"git.sapphic.engineer/roleypoly/v4/discord"
	"git.sapphic.engineer/roleypoly/v4/types"
)

type TestingController struct {
	Guilds discord.IGuildService
}

func (t *TestingController) Routes(r fiber.Router) {
	r.Get("/picker/:version?", t.Picker)
	r.Get("/m/:server/:user", t.GetMember)
}

func (t *TestingController) Picker(c fiber.Ctx) error {
	version := c.Params("version", "main")
	return c.Render("picker/"+version, fiber.Map{})
}

func (t *TestingController) GetMember(c fiber.Ctx) error {
	serverID := c.Params("server")
	userID := c.Params("user")

	g, err := t.Guilds.GetGuild(serverID)
	if err != nil {
		log.Println("testing/get guild: ", err)
		types.NewAPIError(500, err.Error()).Send(c)
	}

	m, err := g.GetMember(userID)
	if err != nil {
		log.Println("testing/get member: ", err)
		types.NewAPIError(500, err.Error()).Send(c)
	}

	return c.JSON(m)
}
